# Class ParamModifier

java.lang.Object
org.apache.jmeter.testelement.AbstractTestElement
org.apache.jmeter.protocol.http.modifier.ParamModifier

All Implemented Interfaces:
  `Serializable, Cloneable, Searchable, PreProcessor, TestElement, TestStateListener`

public class ParamModifier extends AbstractTestElement implements TestStateListener, PreProcessor, Serializable
This modifier will replace any single http sampler's url parameter value with a value from a given range - thereby "masking" the value set in the http sampler. The parameter names must match exactly, and the parameter value must be preset to "*" to diferentiate between duplicate parameter names.

For example, if you set up the modifier with a lower bound of 1, an upper bound of 10, and an increment of 2, and run the loop 12 times, the parameter will have the following values (one per loop): 1, 3, 5, 7, 9, 1, 3, 5, 7, 9, 1, 3

The `ParamMask` object contains most of the logic for stepping through this loop. You can make large modifications to this modifier's behaviour by changing one or two method implementations there.

Version:
  $Revision: 1413957 $
See Also:
  - `ParamMask`
  - Serialized Form

## Field Summary

### Fields inherited from interface TestElement

`COMMENTS, ENABLED, GUI_CLASS, NAME, TEST_CLASS`

## Constructor Summary

Constructors
Constructor
Description
`ParamModifier()`
Default constructor.

## Method Summary

Modifier and Type
Method
Description
`ParamMask`
`getMask()`
`void`
`process()`
Modifies an entry object to replace the value of any url parameter that matches a defined mask.
`void`
`testEnded()`
Called once for all threads after the end of a test.
`void`
`testEnded(String host)`
Called once for all threads after the end of a test.
`void`
`testStarted()`
Called just before the start of the test from the main engine thread.
`void`
`testStarted(String host)`
Called just before the start of the test from the main engine thread.

### Methods inherited from class AbstractTestElement

`addPropertiesValues, addProperty, addProperty, addTestElement, canRemove, clear, clearTemporary, clearTestElementChildren, clone, emptyTemporary, equals, getComment, getName, getProperty, getPropertyAsBoolean, getPropertyAsBoolean, getPropertyAsDouble, getPropertyAsFloat, getPropertyAsInt, getPropertyAsInt, getPropertyAsLong, getPropertyAsLong, getPropertyAsString, getPropertyAsString, getSearchableTokens, getThreadContext, getThreadName, hashCode, isEnabled, isRunningVersion, isTemporary, logProperties, mergeIn, propertyIterator, recoverRunningVersion, removeProperty, setComment, setEnabled, setName, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setRunningVersion, setTemporary, setThreadContext, setThreadName, traverse, traverseCollection, traverseMap, traverseProperty`

### Methods inherited from class Object

`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ParamModifier

public ParamModifier()
Default constructor.

## Method Details

### getMask

public ParamMask getMask()

### testStarted

public void testStarted()
Description copied from interface: `TestStateListener`

Called just before the start of the test from the main engine thread. This is before the test elements are cloned. Note that not all the test variables will have been set up at this point.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testStarted` in interface `TestStateListener`
See Also:
  - `StandardJMeterEngine.run()`

### testStarted

public void testStarted(String host)
Description copied from interface: `TestStateListener`

Called just before the start of the test from the main engine thread. This is before the test elements are cloned. Note that not all the test variables will have been set up at this point.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testStarted` in interface `TestStateListener`
Parameters:
  `host` - name of host
See Also:
  - `StandardJMeterEngine.run()`

### testEnded

public void testEnded()
Description copied from interface: `TestStateListener`

Called once for all threads after the end of a test. This will use the same element instances as at the start of the test.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testEnded` in interface `TestStateListener`
See Also:
  - `StandardJMeterEngine.stopTest()`

### testEnded

public void testEnded(String host)
Description copied from interface: `TestStateListener`

Called once for all threads after the end of a test. This will use the same element instances as at the start of the test.

N.B. testStarted() and testEnded() are called from different threads.

Specified by:
  `testEnded` in interface `TestStateListener`
Parameters:
  `host` - name of host
See Also:
  - `StandardJMeterEngine.stopTest()`

### process

public void process()
Modifies an entry object to replace the value of any url parameter that matches a defined mask.

Specified by:
  `process` in interface `PreProcessor`